/***************************************************************************
                          explosion.cpp  -  description
                             -------------------
    begin                : Sat Feb 9 2002
    copyright            : (C) 2002 by funthing (Matthias Zisler)
    email                : matthias@zislers.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "explosion.h"
#include "resources.h"
#include "sprite.h"
#include "map_sample.h"
#include "maptile_normal.h"
#include "maptile_empty.h"
#include "map.h"
#include "tool.h"
#include "tool_bomb.h"
#include "tool_bbomb.h"
#include "player.h"
#include "game.h"
#include "timer.h"


int Explosion::xs[13]={64, 32, 64, 96, 32, 64, 96, 0, 128, 32, 64, 96, 64};
int Explosion::ys[13]={0, 32, 32, 32, 64, 64, 64, 64, 64, 96, 96, 96, 128};

Explosion::Explosion(int _x, int _y, bool _big, Map_Sample* _sample) : Effects(_x, _y, _sample)
{
	big=_big;
	sprite=new Sprite(Resources::Explosion(), 0.1f, 0, 8);
	sprite->set_loop(false);
	sprite->play_once();
	once=false;
	timer=new Timer;

  switch(ran(2))
  {
    case 0:
    PLAY(Resources::Explode());
    break;
    case 1:
    PLAY(Resources::Explode1());
    break;
    case 2:
    PLAY(Resources::Explode2());
    break;
  }
}
Explosion::~Explosion()
{
}
void Explosion::act()
{
	if(timer->time_elapsed()>=0.8f)
	{
		this->set_delme();
	
		for(int i=0; i<=12; i++)
		{
			if(sample->get_tool(map_x()+xs[i], map_y()+ys[i])->get_ttype()==TBOMB)
			static_cast <Tool_bomb*> (sample->get_gameobject(map_x()+xs[i], map_y()+ys[i]))->lit();

			if(sample->get_tool(map_x()+xs[i], map_y()+ys[i])->get_ttype()==TBIGBOMB)
			static_cast <Tool_bbomb*> (sample->get_gameobject(map_x()+xs[i], map_y()+ys[i]))->lit();
		}

		if(big)
		sample->map->fit();
	}
	else
	{
		if(!big)
		{
			for(int i=0; i<=12; i++)
			{
				if(sample->map->get_maptile(map_x()+xs[i], map_y()+ys[i])->get_type()==NORMAL)
				static_cast <Maptile_normal*> (sample->map->get_maptile(map_x()+xs[i], map_y()+ys[i]))->dig();	
				sample->kill(map_x()+xs[i], map_y()+ys[i]);
			}
		}
		else
		{
			if(!once)
			for(int i=0; i<=12; i++)
			{
				sample->get_gameobject(map_x()+xs[i], map_y()+ys[i])->set_bbomb();
				sample->map->get_maptile(map_x()+xs[i], map_y()+ys[i])->set_delme();
		
				if(sample->map->get_maptile(map_x()+xs[i], map_y()+ys[i])->get_type()!=DUMMY)
				new Maptile_empty(map_x()+xs[i], map_y()+ys[i], (WorldType)(0), sample->map);	
				once=true;
				sample->kill(map_x()+xs[i], map_y()+ys[i]);
			}
		}
	}
}
void Explosion::show()
{
	sprite->put_screen(x, y);
}
