/***************************************************************************
                          monk.cpp  -  description
                             -------------------
    begin                : Sat Feb 9 2002
    copyright            : (C) 2002 by funthing (Matthias Zisler)
    email                : matthias@zislers.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "monk.h"
#include "monk_ai.h"
#include "resources.h"
#include "timer.h"
#include "sprite.h"
#include "map_sample.h"
#include "map.h"
#include "maptile.h"
#include "maptile_teleporter.h"
#include "player.h"
#include "tool_gold.h"
#include "game.h"
#include "map.h"
#include "config.h"

Monk::Monk(int _x, int _y, int _dx, int _dy, Map_Sample* _sample) : Gameobject(_x, _y, _sample)
{
	dx=_dx;
	dy=_dy;
	got=MONK;
	ctimer=new Timer;
	ttimer=new Timer;
	gased=trapped=false;
	dir=STOPPED;
	port=false;
	transfer=false;
	px=py=0;
  bar=new Timer;
  if(Config::get_skill()==1)
  skill=80.0f;
  else if(Config::get_skill()==2)
  skill=100.0f;
  else if(Config::get_skill()==3)
  skill=180.0f;

	speed=skill;
	sur=Resources::Monk();
	sprite=new Sprite(sur, 0.2f, 0, 3);
	timer->reset();
	falling=false;
	fob=false;
	bl=1;
	hole=false;
	have_gold=-1;
	eating=false;
  po=false;
	monk_ai=new Monk_Ai(this, sample);	//attach the brain :)
}
Monk::~Monk()
{
}
bool Monk::in_hole()
{
	return hole;
}
void Monk::die()
{

	if(!transfer)
	{
		if(dx!=0)
		{
			x=dx;
			y=dy;
		}
		else
		get_ran_pos();

		have_gold=-1;
		hole=false;	
		gased=trapped=false;
		dir=STOPPED;
		speed=skill;
		ctimer->reset();
		timer->reset();
		sprite->set_new(0.3f, 22, 23);
		port=false;
		transfer=false;
		falling=false;
		fob=false;
		bl=1;
    po=false;
	}
}
void Monk::show()
{
	if(transfer!=true)
	sprite->put_screen(x, y);
	else
	Resources::Tiles()->put_screen(px, py, 40);	
}
void Monk::act()
{
	monk_ai->act();	//update the brain :)

	if(!gased && !trapped && !eating)
	{
		
		if(!transfer)
  	{
			check_movement();
			check_gom();
		}
		else
		check_transfer();
	}
	else
	{
		if(gased && ctimer->time_elapsed()>=2.8f && !(sample->get_map_gameobject(map_x(16), map_y())->get_type()==GASCLOUD || sample->get_map_gameobject(map_x(16)+32, map_y())->get_type()==GASCLOUD || sample->get_map_gameobject(map_x(16)+64, map_y())->get_type()==GASCLOUD))
		{
			gased=false;
			trapped=false;
		}
		else if(eating && ctimer->time_elapsed()>=0.8f)
		{
			eating=false;
		}
	}
	timer->reset();
}
void Monk::trap()
{
	if(!port)
	{
		sprite->set_new(0.3f, 17, 18);
		trapped=true;

		if(have_gold!=-1)
		{
			new Tool_gold(map_x(16), map_y(), have_gold, sample);
			have_gold=-1;
		}
	}
}
void Monk::gas()
{
	if(!trapped && !port && !falling)
	{
		sprite->set_new(0.3f, 22, 24);		
		trapped=true;
		ctimer->reset();
		gased=true;

		if(have_gold!=-1)
		{
			new Tool_gold(map_x(16), map_y(), have_gold, sample);
			have_gold=-1;
		}
	}
}
void Monk::teleport(Maptile_teleporter *_dest)
{
	if(!port)
	{
		x=map_x(16);
		y=map_y(16);
		port=true;
		dest=_dest;
		transfer=true;
		px=x;
		py=y;
 		ttimer->reset();
	}
}
void Monk::check_transfer()
{
	if(((px>=dest->get_x() && x<=dest->get_x()) || (px<=dest->get_x() && x>=dest->get_x())) && ((py>=dest->get_y() && y<=dest->get_y()) || (py<=dest->get_y() && y>=dest->get_y())))
	{
		if(transfer)
		{
			x=dest->get_x();
			y=dest->get_y();
			dest->sprite->play_once();
			transfer=false;
		}
	}
	else
	{
			if(dest->get_x()<px)
			px-=(int)((ran(200)+80)*ttimer->time_elapsed());
			else if(dest->get_x()>px)
			px+=(int)((ran(200)+80)*ttimer->time_elapsed());
			if(dest->get_y()<py)
			py-=(int)((ran(200)+80)*ttimer->time_elapsed());
			else if(dest->get_y()>py)
			py+=(int)((ran(200)+80)*ttimer->time_elapsed());
			ttimer->reset();
	}
}
void Monk::get_ran_pos()
{
	int rx=(ran(29)+1)*32;
	int ry=(ran(20)+1)*32;

	while(sample->map->get_maptile(rx, ry)->get_type()!=EMPTY)
	{
		rx=(ran(29)+1)*32;
		ry=(ran(20)+1)*32;
	}
	x=rx;
	y=ry;
}
void Monk::check_movement()
{
	if(sample->map->get_maptile(map_x(16), map_y())->get_type()!=TELEPORTER)
	{
		port=false;
	}

	if(sample->map->get_maptile(map_x(16), map_y(16))->get_digged())
	{
		if(!hole)
		{
			y=sample->map->get_maptile(map_x(16), map_y(16))->get_y();	
			ctimer->reset();
		}
		sprite->set_new(10.0f, 22, 22);
		hole=true;
		falling=false;

		if(have_gold!=-1)
		{
			if(sample->map->get_maptile(map_x(16), map_y(16)-32)->get_type()==EMPTY) {
				new Tool_gold(map_x(16), map_y()-32, have_gold, sample);
				have_gold=-1;
			}
		}
	}

  if(hole && !sample->get_gameobjectp(map_x(16), map_y(16)-32))
  {
    if(!po)
    {
      ctimer->reset();
      po=true;
    }
  }

	if(hole)
	{
		if(ctimer->time_elapsed()>=6.0f && monk_ai->is_left() && move_hleft())
		{
			x=x-32;
			y=y-32;
			po=hole=false;
		}
		else if(ctimer->time_elapsed()>=6.0f && monk_ai->is_right() && move_hright())
		{
 			x=x+32;
			y=y-32;
			po=hole=false;
		}
	}
	else
	if(sample->map->get_maptile(map_x(16), map_y())->get_type()==WATER && sample->map->get_maptile(map_x(16), map_y()+32)->get_type()!=WATER)
	{
		die();
		sprite->set_new(10.0f, 22, 23);
		y=sample->map->get_maptile(map_x(16), map_y())->get_y();
	}
	else if((!hole && sample->get_monkih(map_x(16), map_y(16)+32)==false && (sample->map->get_maptile(map_x(16), map_y()+32)->is_fallt() || sample->map->get_maptile(map_x(16), map_y()+32)->get_type()==WATER) && sample->map->get_maptile(map_x(16), map_y(16))->get_type()!=LADDER && sample->map->get_maptile(map_x(16), map_y())->get_type()!=BAR) || (fob && !hole))
	{
		move(DOWN, speed+60.0f);
		falling=true;
		sprite->set_new(0.1f, 22, 24);
		x=sample->map->get_maptile(map_x(16), map_y())->get_x();

		if((sample->map->get_maptile(map_x(16), map_y()+32)->get_type()!=WATER && sample->map->get_maptile(map_x(16), map_y()+32)->is_blocking()) || sample->map->get_maptile(map_x(16), map_y()+32)->get_type()==LADDER)
		{
			y=sample->map->get_maptile(map_x(16), map_y())->get_y();
			dir=STOPPED;
			falling=false;
			fob=false;
			sprite->set_new(10.0f, 22, 23);
		}

		if(sample->map->get_maptile(map_x(16), map_y()+32)->get_type()==SLIME) {
			if(fob==true && sample->map->get_maptile(map_x(16), map_y()-32*bl)->get_type()==BAR)
			{
				fob=false;
				falling=false;
				bl++;
			}
			else if(fob==true && sample->map->get_maptile(map_x(16), map_y())->get_type()!=BAR)
			{
				falling=false;
				fob=false;
				bl=0;
			}
		}
	}
	else
	{
	  falling=false;

		if(monk_ai->is_left() && !sample->map->get_maptile(map_x(), map_y())->is_blocking())
		{
			if(sample->map->get_maptile(map_x(16), map_y())->get_type()==BAR)
			{
				y=sample->map->get_maptile(map_x(16), map_y())->get_y();
				sprite->set_new(0.2f, 9, 12);
				move(LEFT, speed);
			}
			else
			{
				if(sample->map->get_maptile(map_x(16), map_y()+32)->get_type()==SLIME)
				move(LEFT, 80);
				else
				move(LEFT, speed);

				sprite->set_new(1, 0.2f, 0, 3);
			}


			if(sample->map->get_maptile(map_x(16), map_y(16))->get_type()==LADDER || sample->map->get_maptile(map_x(16), map_y(16)+32)->get_type()==LADDER)
			y=sample->map->get_maptile(map_x(16), map_y(16))->get_y();
		}
		else if(monk_ai->is_right() && (!sample->map->get_maptile(map_x()+32, map_y())->is_blocking() || !sample->map->get_maptile(map_x(-1)+32, map_y())->is_blocking()))
		{
			if(sample->map->get_maptile(map_x(16), map_y())->get_type()==BAR)
			{
				y=sample->map->get_maptile(map_x(16), map_y())->get_y();
				sprite->set_new(1, 0.2f, 24, 27);
				move(RIGHT, speed);
			}
			else
			{
				if(sample->map->get_maptile(map_x(16), map_y()+32)->get_type()==SLIME)
				move(RIGHT, 80);
				else
				move(RIGHT, speed);

				sprite->set_new(0.2f, 3, 6);
			}

			if(sample->map->get_maptile(map_x(16), map_y(16))->get_type()==LADDER || sample->map->get_maptile(map_x(), map_y(16)+32)->get_type()==LADDER)
			y=sample->map->get_maptile(map_x(16), map_y(16))->get_y();
		}
		else if(dir!=STOPPED && monk_ai->is_up() && (sample->map->get_maptile(map_x(16), map_y()+32)->get_type()==LADDER || sample->map->get_maptile(map_x(16), map_y())->get_type()==LADDER) && !sample->map->get_maptile(map_x(16), map_y())->is_blocking())
		{
			x=sample->map->get_maptile(map_x(16), map_y())->get_x();
			sprite->set_new(0.2f, 6, 9);
			move(UP, speed);
		}
		else if(monk_ai->is_down() && sample->map->get_maptile(map_x(16), map_y())->get_type()==BAR)
		{
      if(bar->time_elapsed()>=0.1f)
			{
        y=y+32;
  			x=sample->map->get_maptile(map_x(16), map_y())->get_x();
        bar->reset();
      }
		}
		else if(monk_ai->is_down() && (sample->map->get_maptile(map_x(16), map_y()+32)->get_type()==LADDER || sample->map->get_maptile(map_x(16), map_y())->get_type()==LADDER || sample->map->get_maptile(map_x(16), map_y()-32)->get_type()==LADDER) && (!sample->map->get_maptile(map_x(16), map_y()+32)->is_blocking() || sample->map->get_maptile(map_x(16), map_y()+32)->get_type()==WATER))
		{
			x=sample->map->get_maptile(map_x(16), map_y())->get_x();
			sprite->set_new(1, 0.2f, 6, 9);
			move(DOWN, speed);
		}
		else
		{
			if((dir==UP || dir==DOWN) && (sample->map->get_maptile(map_x(16), map_y())->get_type()==LADDER || sample->map->get_maptile(map_x(16), map_y()+32)->get_type()==LADDER))
			sprite->set_new(10.0f, 8, 8);
			else if((dir==LEFT || dir==DOWN) && sample->map->get_maptile(map_x(16), map_y())->get_type()==BAR)
			{
				sprite->set_new(10.0f, 9, 9);
				y=sample->map->get_maptile(map_x(16), map_y())->get_y();
			}
			else if(dir==RIGHT && sample->map->get_maptile(map_x(16), map_y())->get_type()==BAR)
			{
				sprite->set_new(10.0f, 27, 27);
				y=sample->map->get_maptile(map_x(16), map_y())->get_y();
			}
			else if(dir==RIGHT)
			sprite->set_new(10.0f, 5, 5);
			else if(dir==LEFT)
			sprite->set_new(10.0f, 0, 0);
			else if(dir==STOPPED)
			sprite->set_new(10.0f, 27, 27);
		}
	}
}
void Monk::check_gom()
{
	if(have_gold==-1 && sample->get_gameobject(map_x(16), map_y(16))->get_type()==TOOL)
	{
		if(sample->get_tool(map_x(16), map_y(16))->get_ttype()==TGOLD)
		{
			sample->get_gameobject(map_x(16), map_y(16))->set_delme();

			if(static_cast <Tool_gold*> (sample->get_gameobject(map_x(16), map_y(16)))->get_g()==0)
			have_gold=0;
			if(static_cast <Tool_gold*> (sample->get_gameobject(map_x(16), map_y(16)))->get_g()==1)
			have_gold=1;
			if(static_cast <Tool_gold*> (sample->get_gameobject(map_x(16), map_y(16)))->get_g()==2)
			have_gold=2;			
		}
	}

	if(!falling && sample->p1->is_hunted() && sample->p1->map_x(16)==map_x(16) && sample->p1->map_y()==map_y())
	{
		sprite->set_new(0.2f, 12, 16);
		sample->p1->eaten();
		eating=true;
		ctimer->reset();				
	}	
	if(!falling && sample->map->game->get_t()==true)
	if(sample->p2->is_hunted() && sample->p2->map_x(16)==map_x(16) && sample->p2->map_y()==map_y())
	{
		sprite->set_new(0.2f, 18, 24);
		sample->p2->eaten();
		eating=true;
		ctimer->reset();
	}
}
bool Monk::have_g()
{
	if(have_gold!=-1)
	return true;
	else
	return false;
}
bool Monk::move_left()
{
	if(!sample->map->get_maptile(map_x(16)-32, map_y(16))->is_blocking())
	return true;	
	else
	return false;
}
bool Monk::move_right()
{
	if(!sample->map->get_maptile(map_x(16)+32, map_y(16))->is_blocking())
	return true;	
	else
	return false;

}
bool Monk::move_up()
{
  if(sample->map->get_maptile(map_x(16), map_y(16))->get_type()==BAR)
  return false;

	if(((sample->map->get_maptile(map_x(16), map_y()+32)->get_type()==LADDER && sample->map->get_maptile(map_x(16), map_y(16))->get_type()!=EMPTY) || sample->map->get_maptile(map_x(16), map_y())->get_type()==LADDER) && !sample->map->get_maptile(map_x(16), map_y(16)-32)->is_blocking())
	return true;

	return false;
}
bool Monk::move_down()
{
	if(sample->map->get_maptile(map_x(16), map_y(16))->get_type()==BAR || ((sample->map->get_maptile(map_x(16), map_y(16))->get_type()==LADDER || sample->map->get_maptile(map_x(16), map_y(16)+32)->get_type()==LADDER) && sample->map->get_maptile(map_x(16), map_y(16)+32)->is_blocking()==false))
		return true;

	return false;
}
bool Monk::move_hright()
{
	if(hole && sample->map->get_maptile(map_x(16)+32, map_y(16)-32)->is_blocking()==false && !sample->get_gameobjectp(map_x(16), map_y(16)-32))
	return true;
	else
	return false;
}
bool Monk::move_hleft()
{
	if(hole && sample->map->get_maptile(map_x(16)-32, map_y(16)-32)->is_blocking()==false && !sample->get_gameobjectp(map_x(16), map_y(16)-32))
	return true;
	else
	return false;
}